#ifeq ($(TARGET_PRODUCT), crane_cdr)

MY_LOCAL_PATH := $(call my-dir)
include $(call all-makefiles-under, $(MY_LOCAL_PATH)/extra)

LOCAL_PATH := $(MY_LOCAL_PATH)

include $(CLEAR_VARS)

#ifneq ($(filter crane-cdr%,$(TARGET_DEVICE)),)

LOCAL_LDFLAGS += -L$(TOP)/frameworks/prebuilts \
-lminigui_ths

ifneq ($(BOARD_WIFI_VENDOR),)
	LOCAL_CFLAGS += -DAPP_WIFI
	LOCAL_LDFLAGS += -L$(TOP)/frameworks/prebuilts \
		-lhttpsrv \
		-law_net
endif
#strict compile option
#LOCAL_CFLAGS += -Werror  -Wall -Wno-unused-parameter -Wno-reorder
LIMIT_TARGET := crane_sdv
ifeq ($(TARGET_PRODUCT), $(LIMIT_TARGET))
	LOCAL_CFLAGS += -DCRANE_SDV
endif


LOCAL_SHARED_LIBRARIES := \
	libmedia_proxy \
	libcutils \
	libutils \
	libbinder \
	libdatabase \
	libstorage \
	libhardware \
	libhardware_legacy \
	libcpuinfo \
	libmedia \
	libstandby \
	libcamera_client \
	libGsensor \
	libjpeg

ifneq ($(BOARD_RF_MODULE),)
	LOCAL_SHARED_LIBRARIES += librfmodule
endif

ifneq ($(BOARD_WIFI_VENDOR),)
	LOCAL_SHARED_LIBRARIES += libnetutils
endif

SRC_TAG := src/camera  \
	src/display \
	src/event \
	src/misc \
	src/power \
	src/storage  \
	src/widget \
	src/window

ifneq ($(BOARD_WIFI_VENDOR),)
	SRC_TAG += src/network_manager \
				src/server
endif

INC_TAG := include

define inc_sub_dir
$(shell cd $(LOCAL_PATH);find $(1)/* -type d)
endef

SRC_SUB_DIRS := $(call sub_dir, $(SRC_TAG))
INC_SUB_DIRS := $(addprefix $(LOCAL_PATH)/,$(call inc_sub_dir, $(INC_TAG)))

SRC_FILES := $(call all-cpp-files-under, $(SRC_TAG))
SRC_FILES += src/storage/rgb2jpeg.c
LOCAL_SRC_FILES := $(SRC_FILES)
LOCAL_C_INCLUDES := $(INC_SUB_DIRS) \
	$(TOP)/external/stlport/stlport \
	$(TOP)/external/jpeg \
	$(TOP)/frameworks/include/binder \
	$(TOP)/frameworks/include/include_gui \
	$(TOP)/frameworks/include/include_media/media \
	$(TOP)/frameworks/av/display \
	$(TOP)/frameworks/include \
	$(TOP)/frameworks/include/include_media/display \
	$(TOP)/frameworks/include/include_database \
	$(TOP)/frameworks/include/include_battery \
	$(TOP)/frameworks/include/include_storage \
	$(TOP)/frameworks/include/include_rtsp \
	$(TOP)/frameworks/include/include_http \
	$(TOP)/frameworks/include/standby \
	$(TOP)/frameworks/include/include_adas \
	$(TOP)/device/softwinner/common/hardware/camera/tvin \
	$(TOP)/device/softwinner/common/hardware/include
#	$(LOCAL_PATH)/include/window \
	$(LOCAL_PATH)/include/camera \
	$(LOCAL_PATH)/include/misc \
	$(LOCAL_PATH)/include/display \
	$(LOCAL_PATH)/include/storage \
	$(LOCAL_PATH)/include/event \
	$(LOCAL_PATH)/include/power \

ifneq ($(BOARD_WIFI_VENDOR),)
	ifeq ($(strip $(YOUKU_PLATFORM_SUPPORT)),true)
		LOCAL_C_INCLUDES += \
			$(TOP)/device/softwinner/crane-cdr/app/newcdr/extra/ykcamera_sdk/include
		LOCAL_SHARED_LIBRARIES += libykcamera
	endif
endif

LOCAL_MODULE_TAGS := optional
LOCAL_MODULE := newcdr

include $(BUILD_EXECUTABLE)

include $(CLEAR_VARS)
LOCAL_SRC_FILES :=  \
	fb_color.c 

LOCAL_C_INCLUDES := \
	$(TOP)/frameworks/include/include_gui
	
LOCAL_LDFLAGS := -L$(TOP)/frameworks/prebuilts -lminigui_ths

LOCAL_MODULE_TAGS := optional
LOCAL_MODULE := fbDemo

include $(BUILD_EXECUTABLE)
include $(CLEAR_VARS)
LOCAL_SRC_FILES :=  \
	key_test.c

LOCAL_MODULE_TAGS := optional
LOCAL_MODULE := keyTest

include $(BUILD_EXECUTABLE)

#endif

