#ifndef _CAMERA_H
#define _CAMERA_H

#include "platform.h"

#define CAM_CNT 2
enum{
	CAM_CSI = 0,
	CAM_UVC,
	CAM_TVD
};

#define CAM_CSI_NET CAM_CNT+CAM_CSI
#define CAM_UVC_NET CAM_CNT+CAM_UVC

enum CameraIdRecord{
	CAMERA_CSI_RECORD = CAM_CSI,
	CAMERA_UVC_RECORD = CAM_UVC,
	CAMERA_CSI_NET_RECORD,
	CAMERA_UVC_NET_RECORD,
	CAMERA_CSI_NET_SMALL_RECORD     //camera_csi small  record
};

typedef enum {
	ImageQuality1M = 0,
	ImageQuality3M,
	ImageQuality5M,
	ImageQuality8M,
	CSIImageQualityNet,
	UVCImageQualityNet,
}ImageQuality_t;

typedef enum{
	NORMAL_TAKE_PIC = 0,
	SMALL_TAKE_PIC,
	GSENSOR_TAKE_PIC,
	SCREENSHOT_TAKE_PIC,
}TakePicType;

#define NET_JPEG_QUALITY 20
#define NORMAL_JPEG_QUALITY 95

// #define CSI_1080P
//#define UVC_1080P	//has no effect on recorder

#define FRONT_CAM_FRAMERATE 30
#define BACK_CAM_FRAMERATE 25

#ifdef CRANE_SDV
#define FRONT_CAM_FRAMERATE 60
#endif

#define CAM_BITRATE (5*1024*1024)

#define FRONT_CAM_BITRATE (14*1024*1024)
#define BACK_CAM_BITRATE (8*1024*1024)

//csi preview size
#define CSI_PREVIEW_WIDTH	960
#define CSI_PREVIEW_HEIGHT	540

//uvc preview size
#define UVC_PREVIEW_WIDTH	640
#define UVC_PREVIEW_HEIGHT	360
#define UVC_PREVIEW_WIDTH_IPS	320
#define UVC_PREVIEW_HEIGHT_IPS	192


//csi net bitrate and preview width/height
#define FRONT_CAM_NET_BITRATE (2*1024*1024)
#define FRONT_CAM_NET_PREVIEW_WIDTH 1280
#define FRONT_CAM_NET_PREVIEW_HEIGHT 720

//uvc net bitrate and preview width/height
#define BACK_CAM_NET_BITRATE (2*1024*1024)
#define BACK_CAM_NET_PREVIEW_WIDTH 1280
#define BACK_CAM_NET_PREVIEW_HEIGHT 720

//small video
#define SMALL_VIDEO_BITRATE	(1*1024*1024)
#define SMALL_VIDEO_WIDTH	960
#define SMALL_VIDEO_HEIGHT	540
#define SMALL_VIDEO_FRAMERATE 30

#define UVC_FLIP

#endif
