#ifndef _YOUKU_RESP_CMDS_
#define _YOUKU_RESP_CMDS_

#include "YoukuCmdsCallback.h"
#include "YoukuService.h"
#include "windows.h"

typedef int (YoukuCmdsCallback::*_respCallback)(int value, void *data);

typedef struct command_info_s {
	int req_cmd;
	_respCallback respCallback;
} command_info_t;

command_info_t s_commands[] = {
	{	CAM_REQ_CAMERA_STATUS 	,				NULL	}, // 0
	{	CAM_REQ_VIDEO_DEFAULT_MODE	,				NULL	},
	{	CAM_REQ_VIDEO_RESOLUTION	, NULL},
	{	CAM_REQ_VIDEO_FPS	, NULL},
	{	CAM_REQ_VIDEO_RESOLUTION_FPS	, &YoukuCmdsCallback::SetVideoResolutionFPS},
	{	CAM_REQ_VIDEO_FOV	,				NULL	}, // 5
	{	CAM_REQ_VIDEO_TIMELAPSE_RATE	, NULL},
	{	CAM_REQ_VIDEO_LOOPING	, &YoukuCmdsCallback::SetVideoCyclicRecord},
	{	CAM_REQ_VIDEO_PIV	, NULL},
	{	CAM_REQ_VIDEO_LOW_LIGHT	,				NULL	},
	{	CAM_REQ_VIDEO_SPOT_METER	,			NULL	}, // 10
	{	CAM_REQ_VIDEO_EFFECT	,				NULL	},
	{	CAM_REQ_VIDEO_WHITE_BALANCE	, &YoukuCmdsCallback::SetVideoWriteBalance},
	{	CAM_REQ_VIDEO_COLOR	,				NULL	},
	{	CAM_REQ_VIDEO_ISO	,				NULL	},
	{	CAM_REQ_VIDEO_SHARPNESS	,				NULL	}, //15
	{	CAM_REQ_VIDEO_EV	, &YoukuCmdsCallback::SetVideoEV},
	{	CAM_REQ_VIDEO_DATETIME_PRINT	, &YoukuCmdsCallback::SetVideoDateWaterPrint},
	{	CAM_REQ_VIDEO_AUDIO_RECORD	, &YoukuCmdsCallback::SetAudioRecord},
	{	CAM_REQ_VIDEO_HDR	,			NULL		},
	{	CAM_REQ_VIDEO_WDR	,				NULL	}, // 20
	{	CAM_REQ_PHOTO_DEFAULT_MODE	,				NULL	},
	{	CAM_REQ_PHOTO_RESOLUTION	, &YoukuCmdsCallback::SetPhotoResolution},
	{	CAM_REQ_PHOTO_CONTINUOUS_RATE	, NULL},
	{	CAM_REQ_PHOTO_EXPOSURE_TIME	,				NULL 	},
	{	CAM_REQ_PHOTO_SPOT_METER	,				NULL	}, // 25
	{	CAM_REQ_PHOTO_EFFECT	,				NULL	},
	{	CAM_REQ_PHOTO_WHITE_BALANCE	, &YoukuCmdsCallback::SetPhotoWriteBalance},
	{	CAM_REQ_PHOTO_COLOR	,				NULL	},
	{	CAM_REQ_PHOTO_ISO	,				NULL	},
	{	CAM_REQ_PHOTO_SHARPNESS	,				NULL	}, // 30
	{	CAM_REQ_PHOTO_HDR	,				NULL	},
	{	CAM_REQ_PHOTO_WDR	,				NULL	},
	{	CAM_REQ_PHOTO_EV	, &YoukuCmdsCallback::SetPhotoEV},
	{	CAM_REQ_PHOTO_FOV	,				NULL	},
	{	CAM_REQ_PHOTO_TIMELAPSE_RATE	, NULL}, // 35
	{	CAM_REQ_PHOTO_CORDINATE	,				NULL	},
	{	CAM_REQ_PHOTO_DATETIME_PRINT	, &YoukuCmdsCallback::SetVideoDateWaterPrint},
	{	CAM_REQ_COMM_STREAM_SIZE	,				NULL	},
	{	CAM_REQ_COMM_STREAM_WINDOW_SIZE	, &YoukuCmdsCallback::SetStreamResolution},
	{	CAM_REQ_COMM_STREAM_BIT_RATE	, &YoukuCmdsCallback::SetStreamBitrate}, // 40
	{	CAM_REQ_COMM_LCD_BRIGHTNESS	,				NULL	},
	{	CAM_REQ_COMM_LCD_LOCK	,				NULL	},
	{	CAM_REQ_COMM_LCD_SLEEP	, &YoukuCmdsCallback::SetLCDSleep},
	{	CAM_REQ_COMM_ORIENTATION	,				NULL	},
	{	CAM_REQ_COMM_LED_BLINK	, NULL}, // &YoukuCmdsCallback::SetLEDBlink}, // 45
	{	CAM_REQ_COMM_QUICK_CAPTURE	,				NULL	},
	{	CAM_REQ_COMM_BEEP_VOLUME	, NULL}, // &YoukuCmdsCallback::SetBeepVolume},
	{	CAM_REQ_COMM_AUTO_POWER_DOWN	, &YoukuCmdsCallback::SetAutoPowerOff},
	{	CAM_REQ_COMM_LOCATE_MODE	,				NULL	},
	{	CAM_REQ_COMM_WIRELESS_MODE	,				NULL	}, // 50
	{	CAM_REQ_COMM_RESET_FACTORY	, &YoukuCmdsCallback::FactoryMode},
	{	CAM_REQ_COMM_FORMAT_SD	, &YoukuCmdsCallback::FormatSDCard},
	{	CAM_REQ_COMM_RESET_SSID	, NULL}, // &YoukuCmdsCallback::SetSSID},
	{	CAM_REQ_COMM_SHUTTER	,&YoukuCmdsCallback::DoShoot},
	{	CAM_REQ_COMM_CHANGE_CAMERA_MODE	, &YoukuCmdsCallback::ChangeCameraMode}, // 55
	{	CAM_REQ_COMM_POWEROFF	, &YoukuCmdsCallback::SetPowerOff},
	{	CAM_REQ_COMM_UPDATE_DOWNLOAD_START	,				NULL	},
	{	CAM_REQ_COMM_UPDATE_DOWNLOAD_DONE	,				NULL	},
	{	CAM_REQ_COMM_UPDATE_DOWNLOAD_CANCEL	,				NULL	},
	{	CAM_REQ_COMM_STORAGE_DELETE_ALL	, &YoukuCmdsCallback::CleanSDCard}, // 60
	{	CAM_REQ_COMM_STORAGE_DELETE	, &YoukuCmdsCallback::DeleteMediaFile},
	{	CAM_REQ_COMM_STORAGE_DELETE_LAST, &YoukuCmdsCallback::DeleteRecentlyMediaFile},
	{	CAM_REQ_COMM_STREAM_ENABLE	, &YoukuCmdsCallback::EnableStream},
	{	CAM_REQ_COMM_THUMBNAIL, NULL},
	{	CAM_REQ_COMM_DEVINFO_GET	, &YoukuCmdsCallback::GetDeviceInfo}, // 65
	{	CAM_REQ_COMM_MEDIA_LIST, NULL},
	{	CAM_REQ_COMM_DATETIME_SYNC, &YoukuCmdsCallback::SetSystemDateTime},
	{	CAM_REQ_COMM_CLEAN_NEW_VIDEO_FLAG, &YoukuCmdsCallback::CleanNewSpecialVideoFlag},
};

#endif // YoukuRespCmds.h

