#ifndef __CDR_H__
#define __CDR_H__

#include <pthread.h>
#include <semaphore.h>

#include <minigui/window.h>

#include "misc.h"
#include "platform.h"

#define TIME_INFINITE 0xFFFFFF
#define WIN_CNT 6

#define LOW_POWER  20

enum {
	WATERMARK_TWM = 0x1,	//time water mark
	WATERMARK_LWM = 0x2,	//plate water mark
};


/* Window ID*/
enum {
	WINDOWID_RECORDPREVIEW = 0,
	WINDOWID_MENU,
	WINDOWID_PLAYBACKPREVIEW,
	WINDOWID_PLAYBACK,
	WINDOWID_STATUSBAR,
	WINDOWID_MAIN
};

#define CDR_FILE_LENGHT			100
#define FORMATTF_TIMER 			10001
#define SHOW_ADAS_FUNCTION 		10002
#define ADAS_FUNCTION_IMAG_NUM	3

enum {
	MSG_RM_MSG_BASE = MSG_USER,
	MSG_RM_LANG_CHANGED,
	MSG_RM_VIDEO_QUALITY,
	MSG_RM_PIC_QUALITY,
	MSG_RM_VIDEO_TIME_LENGTH,
	MSG_RM_WHITEBALANCE,
	MSG_RM_CONTRAST,
	MSG_RM_EXPOSURE,
	MSG_RM_SCREENSWITCH,
	/* NAT */
	MSG_RM_FORMAT_TFCARD,
	MSG_RM_GET_CAPACITY,
	MSG_RM_TAKE_PICTURE,
	MSG_RM_GET_FILELIST,
	MSG_RM_DEL_FILE,
	
	MSG_CDRMAIN_CUR_WINDOW_CHANGED,
	MSG_AUDIO_SILENT,
	MSG_AWMD,
	MSG_WATER_MARK,
	MSG_REFRESH,
	MSG_BATTERY_CHANGED,
	MSG_BATTERY_CHARGING,

	MSG_CONNECT2PC,
	MSG_DISCONNECT_FROM_PC,
	MSG_SESSIONCONNECT,
	MSG_SESSIONDISCONNECT,
	MSG_CLOSE_CONNECT2PC_DIALOG,
	MSG_SHOW_CDR_DIALOG,
	MSG_CLOSE_CDR_DIALOG,
	MSG_SHOW_TIP_LABEL,
	MSG_CLOSE_TIP_LABEL,
	MSG_FORMAT_TFDIALOG,
	MSG_ADAS_AUDIO_VOL,
	MSG_ADAS_FCW_SENSITY,
	MSG_RM_FACTORY_RESET,
	/* set the progress bar time */
	PGBM_SETTIME_RANGE,
	PGBM_SETCURTIME,

	MLM_HILIGHTED_SPACE,	/* 设置MenuList被选中的高亮的item到window边框的距离 */
	MLM_NEW_SELECTED,		/**** 选中了新的item *******/

	/* ************* Status Bar message ******************* */
	STBM_START_RECORD_TIMER,
	STBM_STOP_RECORD_TIMER,
	STBM_RESUME_RECORD_TIMER,
	STBM_GET_RECORD_TIME,
	STBM_UPDATE_TIME,
	STBM_SETLABEL1_TEXT,
	STBM_SETLABEL2_TEXT,
	STBM_TIMELABEL_TEXT,
	STBM_CLEAR_LABEL1_TEXT,
	STBM_MOUNT_TFCARD,
	STBM_VOICE,
	STBM_LOCK,
	STBM_UVC,
	STBM_WIFI,
	STBM_PARK,
	STBM_AWMD,
	STBM_WOND,
	STBM_COUNT_ONCE,
	STBM_SHOW_TIMEHWND,
	/**************** PlayBack Preview  Message ******************/
	MSG_PLB_COMPLETE,
	MSG_UPDATE_LIST,
	MSG_PREPARE_PLAYBACK,
	MSG_SET_VOLUME,
	MSG_STOP_PLAYBACK,

	/**************** MainWindow Message *******************/
	/* old_window ---> new_window, wParam is the old window ID */
	MWM_CHANGE_FROM_WINDOW,
	/* wParam: old window, lParam: new window */
	MWM_CHANGE_WINDOW,
	MSG_WINDOW_CHANGED,
	MSG_WIFI_SWITCH,
#ifdef YOUKU_PLATFORM
	MSG_YOUKU_SERVICE_SWITCH,
	MSG_SMALL_VIDEO_DONE,
#endif
	MSG_OTA_UPDATE,
	MSG_RESET_WIFI_PWD,
	MSG_SET_CURRENT_FILEID,
	MSG_DRAW_ALIGN_LINE,
	MSG_ADAS_SCREEN,
	MSG_SHOW_ADAS_FUNCTION,
	MSG_GSENSOR_SENSITIVITY,
	MSG_IMPACTLEVEL_VALUE,
	MSG_AUTO_SHUTDOWN,
	MSG_TAKE_SMALL_VIDEO,
	MSG_TAKE_SMALL_VIDEO_RESP,
	MSG_GET_STATUSBAR_TIME,
#ifdef APP_ADAS
	MSG_ADAS_SWITCH,
	MSG_KEEP_ADAS_SCREEN_FLAG,
	MSG_RECOVER_ADAS_SCREEN_FLAG
#endif
};


typedef enum {
	LANG_CN = 0,
	LANG_TW = 1,
	LANG_EN = 2,
	LANG_JPN = 3,
	LANG_KR = 4,
	LANG_RS = 5,
	LANG_ERR
}LANGUAGE;

#endif
