  
#ifndef __CDRLANG_H__
#define __CDRLANG_H__

#include <utils/Vector.h>
#include <utils/String8.h>

#include <minigui/common.h>
#include <minigui/gdi.h>

#include "cdr.h"







enum LANG_STRINGS {
	LANG_LABEL_MENU = 0,
	LANG_LABEL_MENU_LICENSE_PLATE_WM,
	LANG_LABEL_MENU_WIFI,
	LANG_LABEL_MENU_PARK,
	LANG_LABEL_MENU_VQ,
	LANG_LABEL_MENU_PQ,
	LANG_LABEL_MENU_VTL,
	LANG_LABEL_MENU_IDD,
	LANG_LABEL_MENU_IDR,
	LANG_LABEL_MENU_VOICEVOL,
	LANG_LABEL_MENU_WB,
	LANG_LABEL_MENU_CONTRAST,
	LANG_LABEL_MENU_EXPOSURE,
	LANG_LABEL_MENU_POR,
	LANG_LABEL_MENU_SS,
	LANG_LABEL_MENU_SILENTMODE,
	LANG_LABEL_MENU_DATE,
	LANG_LABEL_MENU_LANG,
	LANG_LABEL_MENU_TWM,
	LANG_LABEL_MENU_FORMAT,
	LANG_LABEL_MENU_FRESET,
	LANG_LABEL_MENU_AWMD,
	LANG_LABEL_MENU_FIRMWARE,
#ifdef APP_ADAS
	LANG_LABEL_MENU_SMARTALGORITHM,	
#endif
	LANG_LABEL_MENU_ALIGNLINE,
	LANG_LABEL_MENU_GSENSOR,
	LANG_LABEL_MENU_IMPACTLEVEL,
	LANG_LABEL_MENU_FCWSENSITY,
	LANG_LABEL_MENU_SHUTDOWN,
	LANG_LABEL_SUBMENU_LANG_TITLE,
	LANG_LABEL_SUBMENU_LANG_CONTENT0,
	LANG_LABEL_SUBMENU_LANG_CONTENT1,
	LANG_LABEL_SUBMENU_LANG_CONTENT2,
	LANG_LABEL_SUBMENU_LANG_CONTENT3,
	LANG_LABEL_SUBMENU_LANG_CONTENT4,
	LANG_LABEL_SUBMENU_LANG_CONTENT5,
	LANG_LABEL_SUBMENU_VQ_TITLE,
	LANG_LABEL_SUBMENU_VQ_CONTENT0,
	LANG_LABEL_SUBMENU_VQ_CONTENT1,
	LANG_LABEL_SUBMENU_PQ_TITLE,
	LANG_LABEL_SUBMENU_PQ_CONTENT0,
	LANG_LABEL_SUBMENU_PQ_CONTENT1,
	LANG_LABEL_SUBMENU_PQ_CONTENT2,
	LANG_LABEL_SUBMENU_PQ_CONTENT3,
	LANG_LABEL_SUBMENU_VTL_TITLE,
	LANG_LABEL_SUBMENU_VTL_CONTENT0,
	LANG_LABEL_SUBMENU_VTL_CONTENT1,
	LANG_LABEL_SUBMENU_VTL_CONTENT2,
	LANG_LABEL_SUBMENU_WB_TITLE,
	LANG_LABEL_SUBMENU_WB_CONTENT0,
	LANG_LABEL_SUBMENU_WB_CONTENT1,
	LANG_LABEL_SUBMENU_WB_CONTENT2,
	LANG_LABEL_SUBMENU_WB_CONTENT3,
	LANG_LABEL_SUBMENU_WB_CONTENT4,
	LANG_LABEL_SUBMENU_CONTRAST_TITLE,
	LANG_LABEL_SUBMENU_CONTRAST_CONTENT0,
	LANG_LABEL_SUBMENU_CONTRAST_CONTENT1,
	LANG_LABEL_SUBMENU_CONTRAST_CONTENT2,
	LANG_LABEL_SUBMENU_CONTRAST_CONTENT3,
	LANG_LABEL_SUBMENU_CONTRAST_CONTENT4,
	LANG_LABEL_SUBMENU_CONTRAST_CONTENT5,
	LANG_LABEL_SUBMENU_EXPOSURE_TITLE,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT0,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT1,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT2,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT3,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT4,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT5,
	LANG_LABEL_SUBMENU_EXPOSURE_CONTENT6,
	LANG_LABEL_SUBMENU_SS_TITLE,
	LANG_LABEL_SUBMENU_SS_CONTENT0,
	LANG_LABEL_SUBMENU_SS_CONTENT1,
	LANG_LABEL_SUBMENU_SS_CONTENT2,
	LANG_LABEL_SUBMENU_SS_CONTENT3,
	LANG_LABEL_SUBMENU_OK,
	LANG_LABEL_SUBMENU_CANCEL,
	LANG_LABEL_SUBMENU_FORMAT_TITLE,
	LANG_LABEL_SUBMENU_FORMAT_TEXT,
	LANG_LABEL_SUBMENU_FORMATTING_TEXT,
	LANG_LABEL_SUBMENU_FRESET_TITLE,
	LANG_LABEL_SUBMENU_FRESET_TEXT,
	LANG_LABEL_SUBMENU_GSENSOR_TITLE,
	LANG_LABEL_SUBMENU_GSENSOR_CONTENT0,
	LANG_LABEL_SUBMENU_GSENSOR_CONTENT1,
	LANG_LABEL_SUBMENU_GSENSOR_CONTENT2,
	LANG_LABEL_SUBMENU_IMPACTLEVEL_TITLE,
	LANG_LABEL_SUBMENU_IMPACTLEVEL_CONTENT0,
	LANG_LABEL_SUBMENU_IMPACTLEVEL_CONTENT1,
	LANG_LABEL_SUBMENU_IMPACTLEVEL_CONTENT2,
	LANG_LABEL_SUBMENU_FCWSENSITY_TITLE,
	LANG_LABEL_SUBMENU_FCWSENSITY_CONTENT0,
	LANG_LABEL_SUBMENU_FCWSENSITY_CONTENT1,
	LANG_LABEL_SUBMENU_FCWSENSITY_CONTENT2,
	LANG_LABEL_SUBMENU_VOICEVOL_TITLE,
	LANG_LABEL_SUBMENU_VOICEVOL_CONTENT0,
	LANG_LABEL_SUBMENU_VOICEVOL_CONTENT1,
	LANG_LABEL_SUBMENU_VOICEVOL_CONTENT2,
	LANG_LABEL_SUBMENU_SHUTDOWN_TITLE,
	LANG_LABEL_SUBMENU_SHUTDOWN_CONTENT0,
	LANG_LABEL_SUBMENU_SHUTDOWN_CONTENT1,
	LANG_LABEL_SUBMENU_SHUTDOWN_CONTENT2,
	LANG_LABEL_SUBMENU_SHUTDOWN_CONTENT3,
	LANG_LABEL_SUBMENU_SMARTALGORITHM_TITLE,
	LANG_LABEL_SUBMENU_SMARTALGORITHM_CONTENT0,
	LANG_LABEL_SUBMENU_SMARTALGORITHM_CONTENT1,
	LANG_LABEL_SUBMENU_SMARTALGORITHM_CONTENT2,
	LANG_LABEL_SUBMENU_SMARTALGORITHM_CONTENT3,
	LANG_LABEL_SCREEN_SHOT,
	LANG_LABEL_WARNING,
	LANG_LABEL_TIPS,
	LANG_LABEL_NO_TFCARD,
	LANG_LABEL_TFCARD_FULL,
	LANG_LABEL_FORMATTING,
	LANG_LABEL_DATE_TITLE,
	LANG_LABEL_DATE_YEAR,
	LANG_LABEL_DATE_MONTH,
	LANG_LABEL_DATE_DAY,
	LANG_LABEL_DATE_HOUR,
	LANG_LABEL_DATE_MINUTE,
	LANG_LABEL_DATE_SECOND,
	LANG_LABEL_DELETEFILE_TITLE,
	LANG_LABEL_DELETEFILE_TEXT,		/* line 81 */
	LANG_LABEL_SHUTDOWN_TITLE,
	LANG_LABEL_SHUTDOWN_TEXT,		/* line 83*/
	LANG_LABEL_OPEN_USB_STORAGE_DEVICE,
	LANG_LABEL_CLOSE_USB_STORAGE_DEVICE,
	LANG_LABEL_CHARGE_MODE,		/* line 86 */
	LANG_LABEL_LOW_POWER_SHUTDOWN,
	LANG_LABEL_10S_SHUTDOWN,
	LANG_LABEL_SHUTDOWN_NOW,
	LANG_LABEL_30S_NOWORK_SHUTDOWN,
	LANG_LABEL_PLAYBACK_FAIL,
	LANG_LABEL_FILELIST_EMPTY,
	LANG_LABEL_SOS_WARNING,
	LANG_LABEL_WIFI_CONNECT,
	LANG_LABEL_IMPACT_NUM,
	LANG_LABEL_OTA_UPDATE,
	LANG_LABEL_TAKE_PICTURE,
	LANG_LABEL_FORMAT_SDCARD,
	LANG_LABEL_OPEN_PCCAM,
	LANG_LABEL_LICENSE_PLATE_NUMBERS_CN,
	LANG_LABEL_LICENSE_PLATE_NUMBERS_EN,
	LANG_LABEL_INVAILD_TFCATD,
};


using namespace android;

class cdrLang
{
public:
	cdrLang();
	virtual ~cdrLang(){}
	virtual int initLangAndFont(void) = 0;

	int initLabel(void);
	const char* getLabel(unsigned int labelIndex);

	LANGUAGE lang;
	PLOGFONT mLogFont;
	PLOGFONT mLogFont_MSYH;
	PLOGFONT mLogFont_Malgun_Gothic;	//korean font
	PLOGFONT mCurLogFont;
private:
	Vector <String8> label;
	int loadLabelFromLangFile(String8 langFile);
};

#endif
