#ifndef _YOUKU_SERVICE_H_
#define _YOUKU_SERVICE_H_

#include <utils/Thread.h>
#include <youku/ykcamera_common.h>
#include <youku/ykcamera.h>
#include <youku/ykcamera_mediastream.h>

using namespace android;

extern module_value device_status[];
extern module_value setting_status[];

typedef enum _service_status {
	UNINIT = 0,
	INITED,
	STARTED,
} service_status;

typedef struct YoukuDeviceControl {
	int ctrl_cmd;
	int ctrl_item;
	void *ctrl_data;
	void *called;
} YoukuDeviceControl;

class YoukuService
{
public:
	YoukuService();
	~YoukuService();
	int initCamera();
	int startCamera();
	void startYoukuThread();
	void stopYoukuThread();
	int deInitCamera();
	void setCamStatus(module_value* deivce_status, module_value* setting_status);
	camera_status getCamStatus();
	void setRespCallback(youku_camera_request_handler handler);
	int getServiceStatus();
	YKStreamSender *getStreamSender(int streamtype);

	class YoukuServiceThread : public Thread
	{
	public:
		YoukuServiceThread(YoukuService *yk) : Thread(false), mYK(yk){}
		void startThread() {
			run("YoukuServiceThread", PRIORITY_NORMAL);
		}
		void stopThread() {
			requestExitAndWait();
		}
		bool threadLoop() {
			mYK->startCamera();
			return false;
		}
	private:
		YoukuService *mYK;
	};
private:
	int mStatus;
	youku_camera_request_handler mHandler;
	camera_status mCamStatus;
	ykcamera_interface mCamInterface;
	sp<YoukuServiceThread> mYKThread;
	static YKStreamSender *mStreamSender;
};

#endif // YoukuService.h
